## qt-gstreamer 0.10.2

=== CMakeLists.txt ===
project(QtGStreamer)
cmake_minimum_required(VERSION 2.8)
enable_testing()

set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules)
set(QTGSTREAMER_VERSION 0.10.2)

option(QTGSTREAMER_STATIC "Build QtGStreamer as a static library" OFF)
option(QTGSTREAMER_TESTS "Build QtGStreamer's tests" OFF)
option(QTGSTREAMER_EXAMPLES "Build QtGStreamer's examples" ON)
option(QTGSTREAMER_CODEGEN "Build and use QtGStreamer's codegen" OFF)
option(USE_GST_PLUGIN_DIR "Install gstreamer plugins at the system location" ON)
option(USE_QT_PLUGIN_DIR "Install qt plugins at the system location" ON)

include(MacroLogFeature)

find_package(Qt4 COMPONENTS QtCore QtGui)
macro_log_feature(QT4_FOUND "Qt 4" "Required for building everything" "http://qt.nokia.com/" TRUE "4.7")
macro_log_feature(QT_QTOPENGL_FOUND "QtOpenGL"
                                    "Required for OpenGL acceleration in qtvideosink and QtGStreamerUi"
                                    "http://qt.nokia.com/" FALSE "4.7")
macro_log_feature(QT_QTDECLARATIVE_FOUND "QtDeclarative" "Required for building QML support"
                                         "http://qt.nokia.com/" FALSE "4.7")

if (QTGSTREAMER_TESTS)
    macro_log_feature(QT_QTTEST_FOUND "QtTest" "Required for building unit tests"
                                      "http://qt.nokia.com/" FALSE "4.7")
    if (NOT QT_QTTEST_FOUND)
        set(QTGSTREAMER_TESTS OFF)
    endif()
endif()

find_package(Boost 1.39)
macro_log_feature(Boost_FOUND "Boost" "Required for building QtGLib" "http://www.boost.org/" TRUE "1.39")

# this just sets the QTGSTREAMER_* cmake variables
set(BUILDING_QTGSTREAMER TRUE)
find_package(QtGStreamer REQUIRED)

if (${CMAKE_VERSION} VERSION_LESS "2.8.6")
    find_package(Automoc4)
    macro_log_feature(Automoc4_FOUND "Automoc 4" "Required for the build system to generate moc files properly"
                                     "https://projects.kde.org/projects/kdesupport/automoc" TRUE "0.9.88")
else()
    set(Automoc4_FOUND TRUE)
    set(CMAKE_AUTOMOC TRUE)

    macro(automoc4_add_executable)
        add_executable(${ARGV})
    endmacro()

    macro(automoc4_add_library)
        add_library(${ARGV})
    endmacro()
endif()

find_package(GStreamer 0.10.33 COMPONENTS base)
macro_log_feature(GSTREAMER_FOUND "GStreamer" "Required to build QtGStreamer"
                                  "http://gstreamer.freedesktop.org/" TRUE "0.10.33")
macro_log_feature(GSTREAMER_BASE_LIBRARY_FOUND "GStreamer base library"
                                               "Used for building the qwidgetvideosink element"
                                               "http://gstreamer.freedesktop.org/" FALSE "0.10.33")

find_package(GStreamerPluginsBase 0.10.33 COMPONENTS app interfaces video)
macro_log_feature(GSTREAMER_APP_LIBRARY_FOUND "GStreamer app library"
                                              "Required to build QtGStreamerUtils"
                                              "http://gstreamer.freedesktop.org/" TRUE "0.10.33")
macro_log_feature(GSTREAMER_INTERFACES_LIBRARY_FOUND "GStreamer interfaces library"
                                                "Required to build QtGStreamer"
                                                "http://gstreamer.freedesktop.org/" TRUE "0.10.33")
macro_log_feature(GSTREAMER_VIDEO_LIBRARY_FOUND "GStreamer video library"
                                                "Used for building the qwidgetvideosink element"
                                                "http://gstreamer.freedesktop.org/" FALSE "0.10.33")

find_package(GLIB2)
macro_log_feature(GLIB2_FOUND "GLib" "Required to build QtGLib" "http://www.gtk.org/" TRUE)

find_package(GObject)
macro_log_feature(GOBJECT_FOUND "GObject" "Required to build QtGLib" "http://www.gtk.org/" TRUE)

find_package(OpenGL)
macro_log_feature(OPENGL_FOUND "OpenGL"
                               "Required for OpenGL rendering support in qtvideosink (desktop only)"
                               "http://www.opengl.org" FALSE)

find_package(OpenGLES2)
macro_log_feature(OPENGLES2_FOUND "OpenGLES"
                                  "Required for OpenGLES rendering support in qtvideosink (embedded only)"
                                  "http://www.opengl.org" FALSE "2.0")

if (QTGSTREAMER_CODEGEN AND CMAKE_CROSSCOMPILING)
    message(WARNING "Codegen use requested, but we are crosscompiling. Disabling...")
    set(QTGSTREAMER_CODEGEN OFF)
endif()

if (QTGSTREAMER_CODEGEN)
    find_package(FLEX)
    macro_log_feature(FLEX_FOUND "Flex" "Required to build codegen, a helper code generator"
                                 "http://flex.sourceforge.net/" TRUE)

    find_package(BISON)
    macro_log_feature(BISON_FOUND "Bison" "Required to build codegen, a helper code generator"
                                  "http://www.gnu.org/software/bison/" TRUE)
endif()


if (CMAKE_COMPILER_IS_GNUCXX)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra -Wformat-security -Wundef -Wpointer-arith -fno-common")
endif ()

set(LIB_INSTALL_DIR ${CMAKE_INSTALL_PREFIX}/lib${LIB_SUFFIX} CACHE STRING "Destination directory for libraries")
set(INCLUDES_INSTALL_DIR ${CMAKE_INSTALL_PREFIX}/include/QtGStreamer)

if (USE_GST_PLUGIN_DIR)
    set(PLUGINS_INSTALL_DIR ${GSTREAMER_PLUGIN_DIR})
else()
    set(PLUGINS_INSTALL_DIR ${LIB_INSTALL_DIR}/gstreamer-0.10)
endif()

if (USE_QT_PLUGIN_DIR)
    set(IMPORTS_INSTALL_DIR ${QT_IMPORTS_DIR})
else()
    set(IMPORTS_INSTALL_DIR ${LIB_INSTALL_DIR}/qt4/imports)
endif()

if (QTGSTREAMER_CODEGEN AND FLEX_FOUND AND BISON_FOUND)
    add_subdirectory(codegen)
endif()

if (Automoc4_FOUND) # avoid errors about missing automoc4_add_* macros
    add_subdirectory(src)
    add_subdirectory(elements)

    if (QTGSTREAMER_TESTS)
        add_subdirectory(tests)
    endif()

    if (QTGSTREAMER_EXAMPLES)
        add_subdirectory(examples)
    endif()
endif()

# Add uninstall target. Taken from the KDE4 scripts
configure_file("${CMAKE_SOURCE_DIR}/cmake/modules/cmake_uninstall.cmake.in" "${CMAKE_BINARY_DIR}/cmake_uninstall.cmake" @ONLY)
add_custom_target(uninstall "${CMAKE_COMMAND}" -P "${CMAKE_BINARY_DIR}/cmake_uninstall.cmake")

# Add doc target
include(UseDoxygen)
macro_log_feature(DOXYGEN_FOUND "Doxygen" "Used to generate the API documentation"
                                "http://www.doxygen.org/" FALSE)

macro_display_feature_log()

=== codegen/CMakeLists.txt ===
include_directories(${CMAKE_CURRENT_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR} ${QT_INCLUDE_DIR})

flex_target(analyzer analyzer.l ${CMAKE_CURRENT_BINARY_DIR}/analyzer.cpp)
bison_target(parser parser.y ${CMAKE_CURRENT_BINARY_DIR}/parser.cpp COMPILE_FLAGS "--defines")
add_flex_bison_dependency(analyzer parser)

if (MSVC)
    find_path(FLEX_UNISTD_H_DIR unistd.h)
    if (FLEX_UNISTD_H_DIR)
        include_directories(${FLEX_UNISTD_H_DIR})
    endif()
endif()

add_executable(codegen ${FLEX_analyzer_OUTPUTS} ${BISON_parser_OUTPUTS} generator.cpp)
target_link_libraries(codegen ${QT_QTCORE_LIBRARY})

=== elements/CMakeLists.txt ===
set(GST_PACKAGE_NAME "QtGStreamer" CACHE STRING "The name of this package")
set(GST_PACKAGE_ORIGIN "http://gstreamer.freedesktop.org/" CACHE STRING "The origin url of this package")

add_definitions(-DPACKAGE="qt-gstreamer"
                -DPACKAGE_NAME="${GST_PACKAGE_NAME}"
                -DPACKAGE_ORIGIN="${GST_PACKAGE_ORIGIN}"
                -DPACKAGE_VERSION="${QTGSTREAMER_VERSION}"
                -DGST_DISABLE_XML
                -DGST_DISABLE_LOADSAVE)

include_directories(${QT_INCLUDE_DIR} ${GSTREAMER_INCLUDE_DIR} ${GLIB2_INCLUDE_DIR})

if (GSTREAMER_BASE_LIBRARY_FOUND AND GSTREAMER_VIDEO_LIBRARY_FOUND)
    include_directories(${GSTREAMER_BASE_INCLUDE_DIR} ${GSTREAMER_VIDEO_INCLUDE_DIR})
    add_subdirectory(gstqtvideosink)
endif()

=== examples/CMakeLists.txt ===
macro(example_distcheck example)
    add_custom_target(example_${example}_distcheck
        ${CMAKE_COMMAND}
            -DCMAKE_BUILD_TOOL=${CMAKE_BUILD_TOOL}
            -DQT_QMAKE_EXECUTABLE=${QT_QMAKE_EXECUTABLE}
            -DBINARY_DIR=${CMAKE_CURRENT_BINARY_DIR}
            -DSOURCE_DIR=${CMAKE_CURRENT_SOURCE_DIR}
            -DEXAMPLE=${example}
            -P ${CMAKE_CURRENT_SOURCE_DIR}/RunExamplesDistCheck.cmake
    )

    get_target_property(EXAMPLES_DISTCHECK_TARGET examples_distcheck TYPE)
    if(NOT EXAMPLES_DISTCHECK_TARGET)
        add_custom_target(examples_distcheck)
    endif()

    add_dependencies(examples_distcheck example_${example}_distcheck)
endmacro()

add_subdirectory(player)
example_distcheck(player)

add_subdirectory(appsink-src)
example_distcheck(appsink-src)

add_subdirectory(recorder)
example_distcheck(recorder)

add_subdirectory(voip)
example_distcheck(voip)

if (QT_QTDECLARATIVE_FOUND)
    add_subdirectory(qmlplayer)
endif()
example_distcheck(qmlplayer)

=== src/CMakeLists.txt ===
set(EXPORT_TARGET_SET QtGStreamerTargets)

if (QTGSTREAMER_STATIC)
    set(SHARED_OR_STATIC "STATIC")
else()
    set(SHARED_OR_STATIC "SHARED")
    if (CMAKE_COMPILER_IS_GNUCXX AND NOT WIN32)
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fvisibility=hidden -fvisibility-inlines-hidden")
    endif ()
endif()

# Macro to run codegen from the subdirs
macro(run_codegen _dir_name _includes _headers)
    if (QTGSTREAMER_CODEGEN)
        set(_prefixed_headers "")
        foreach(_header ${_headers})
            list(APPEND _prefixed_headers ${_dir_name}/${_header})
        endforeach()

        add_custom_command(OUTPUT ${CMAKE_CURRENT_SOURCE_DIR}/gen.cpp
                           COMMAND codegen
                           ARGS ${_includes} ${_prefixed_headers}
                                > ${CMAKE_CURRENT_SOURCE_DIR}/gen.cpp
                           DEPENDS codegen ${_headers}
                           WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/..)
    endif()

    add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/gen.cpp
                       COMMAND ${CMAKE_COMMAND}
                       ARGS -E copy ${CMAKE_CURRENT_SOURCE_DIR}/gen.cpp
                            ${CMAKE_CURRENT_BINARY_DIR}/gen.cpp
                       DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/gen.cpp
                       COMMENT "Copying gen.cpp to the build directory")
endmacro()

# Macro to install headers from the subdirs
macro(install_headers _dir_name)
    foreach(header ${ARGN})
        get_filename_component(header_path ${header} PATH)
        install(FILES ${header} DESTINATION ${INCLUDES_INSTALL_DIR}/${_dir_name}/${header_path})
    endforeach()
endmacro()

# Setup common environment
include_directories(${QTGSTREAMER_INCLUDES})
add_definitions(${QTGSTREAMER_DEFINITIONS})
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${QTGSTREAMER_FLAGS}")

# Build the libraries
add_subdirectory(QGlib)
add_subdirectory(QGst)

# Build the qml plugin
if (QT_QTDECLARATIVE_FOUND)
    add_subdirectory(qml)
endif()

# Install the cmake scripts that are used to find the installed library from external projects
install(EXPORT ${EXPORT_TARGET_SET} DESTINATION ${LIB_INSTALL_DIR}/QtGStreamer)
install(FILES ${CMAKE_SOURCE_DIR}/cmake/modules/FindQtGStreamer.cmake
        DESTINATION ${LIB_INSTALL_DIR}/QtGStreamer
        RENAME QtGStreamerConfig.cmake)

# Install pkgconfig files
file(GLOB_RECURSE PC_IN_FILES "*.pc.in")
foreach(pc_in_file ${PC_IN_FILES})
    get_filename_component(pc_out_file ${pc_in_file} NAME)
    string(REPLACE ".pc.in" ".pc" pc_out_file ${pc_out_file})
    configure_file(${pc_in_file} ${CMAKE_CURRENT_BINARY_DIR}/${pc_out_file} @ONLY)
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${pc_out_file} DESTINATION ${LIB_INSTALL_DIR}/pkgconfig)
endforeach()

=== elements/gstqtvideosink/CMakeLists.txt ===
include_directories(${CMAKE_CURRENT_BINARY_DIR})

glib2_genmarshal(gstqtvideosinkmarshal
    VOID:POINTER,FLOAT,FLOAT,FLOAT,FLOAT
    VOID:POINTER,DOUBLE,DOUBLE,DOUBLE,DOUBLE
)

set(GstQtVideoSink_SRCS
    utils.cpp
    bufferformat.cpp
    genericsurfacepainter.cpp

    qtvideosinkdelegate.cpp
    qwidgetvideosinkdelegate.cpp

    gstqtvideosinkplugin.cpp
    gstqtvideosinkbase.cpp
    gstqtvideosink.cpp
    gstqwidgetvideosink.cpp

    ${CMAKE_CURRENT_BINARY_DIR}/gstqtvideosinkmarshal.c
)

if (QT_QTOPENGL_FOUND AND (OPENGL_FOUND OR OPENGLES2_FOUND))
    set(GstQtVideoSink_GL_SRCS
        openglsurfacepainter.cpp
        gstqtglvideosinkbase.cpp
        gstqtglvideosink.cpp
    )
    set(GstQtVideoSink_test_GL_SRCS
        openglsurfacepainter.cpp
    )

    if (OPENGLES2_FOUND)
        set(GstQtVideoSink_GL_LIBS ${OPENGLES2_LIBRARY} ${QT_QTOPENGL_LIBRARY})
        include_directories(${OPENGLES2_INCLUDE_DIR} ${QT_QTOPENGL_INCLUDE_DIR})
    else()
        set(GstQtVideoSink_GL_LIBS ${OPENGL_gl_LIBRARY} ${QT_QTOPENGL_LIBRARY})
        include_directories(${OPENGL_INCLUDE_DIR} ${QT_QTOPENGL_INCLUDE_DIR})
    endif()
else()
    add_definitions(-DGST_QT_VIDEO_SINK_NO_OPENGL)
endif()

automoc4_add_library(gstqtvideosink MODULE ${GstQtVideoSink_SRCS} ${GstQtVideoSink_GL_SRCS})
target_link_libraries(gstqtvideosink
    ${QT_QTCORE_LIBRARY}
    ${QT_QTGUI_LIBRARY}
    ${GOBJECT_LIBRARIES}
    ${GSTREAMER_LIBRARY}
    ${GSTREAMER_BASE_LIBRARY}
    ${GSTREAMER_VIDEO_LIBRARY}
    ${GSTREAMER_INTERFACES_LIBRARY}
    ${GstQtVideoSink_GL_LIBS}
)
install(TARGETS gstqtvideosink DESTINATION ${PLUGINS_INSTALL_DIR})


if (QTGSTREAMER_TESTS)
    automoc4_add_executable(qtvideosink_autotest
        autotest.cpp
        utils.cpp
        bufferformat.cpp
        genericsurfacepainter.cpp
        ${GstQtVideoSink_test_GL_SRCS}
    )
    target_link_libraries(qtvideosink_autotest
        ${QT_QTTEST_LIBRARY}
        ${QT_QTCORE_LIBRARY}
        ${QT_QTGUI_LIBRARY}
        ${GOBJECT_LIBRARIES}
        ${GSTREAMER_LIBRARY}
        ${GSTREAMER_BASE_LIBRARY}
        ${GSTREAMER_VIDEO_LIBRARY}
        ${GSTREAMER_INTERFACES_LIBRARY}
        ${GstQtVideoSink_GL_LIBS}
    )
    #add_test(NAME qtvideosink_autotest COMMAND qtvideosink_autotest)
endif()

=== examples/appsink-src/CMakeLists.txt ===
# This file serves as an example of how to use cmake with QtGStreamer.
# It can be used for building this example either in the QtGStreamer source tree or standalone.

project(qtgst-example-appsink-src)

if (NOT BUILDING_QTGSTREAMER)
    find_package(QtGStreamer REQUIRED)
endif()

include_directories(${QTGSTREAMER_INCLUDES})
add_definitions(${QTGSTREAMER_DEFINITIONS})
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${QTGSTREAMER_FLAGS}")

add_executable(appsink-src main.cpp)
target_link_libraries(appsink-src ${QTGSTREAMER_UTILS_LIBRARIES})

=== examples/player/CMakeLists.txt ===
project(qtgst-example-player)

if (NOT BUILDING_QTGSTREAMER)
    find_package(QtGStreamer REQUIRED)

    if (${CMAKE_VERSION} VERSION_LESS "2.8.6")
        find_package(Automoc4 REQUIRED)
    else()
        set(CMAKE_AUTOMOC TRUE)

        macro(automoc4_add_executable)
            add_executable(${ARGV})
        endmacro()
    endif()
endif()

include_directories(${QTGSTREAMER_INCLUDES} ${CMAKE_CURRENT_BINARY_DIR})
add_definitions(${QTGSTREAMER_DEFINITIONS})
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${QTGSTREAMER_FLAGS}")

set(player_SOURCES main.cpp player.cpp mediaapp.cpp)

automoc4_add_executable(player ${player_SOURCES})
target_link_libraries(player ${QTGSTREAMER_UI_LIBRARIES})

=== examples/qmlplayer/CMakeLists.txt ===
project(qtgst-example-qmlplayer)

if (NOT BUILDING_QTGSTREAMER)
    find_package(Qt4 COMPONENTS QtCore QtGui QtDeclarative REQUIRED)
    find_package(QtGStreamer REQUIRED)
    find_package(OpenGL)

    # Use a relative module path to avoid copying FindOpenGLES2.cmake here
    set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/../../cmake/modules)
    find_package(OpenGLES2)

    if (${CMAKE_VERSION} VERSION_LESS "2.8.6")
        find_package(Automoc4 REQUIRED)
    else()
        set(CMAKE_AUTOMOC TRUE)

        macro(automoc4_add_executable)
            add_executable(${ARGV})
        endmacro()
    endif()
else()
    # allow the example to run from the build tree without installing QtGStreamer
    add_definitions(
        -DQTVIDEOSINK_PATH="${QtGStreamer_BINARY_DIR}/elements/gstqtvideosink"
        -DUNINSTALLED_IMPORTS_DIR="${QtGStreamer_BINARY_DIR}/src/qml"
    )
endif()

include_directories(${QTGSTREAMER_INCLUDES} ${CMAKE_CURRENT_BINARY_DIR})
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${QTGSTREAMER_FLAGS}")
add_definitions(${QTGSTREAMER_DEFINITIONS})

if (QT_QTOPENGL_FOUND AND (OPENGL_FOUND OR OPENGLES2_FOUND))
    set(qmlplayer_gl_libs ${QT_QTOPENGL_LIBRARY})
    if (OPENGLES2_FOUND)
        include_directories(${OPENGLES2_INCLUDE_DIR})
    else()
        include_directories(${OPENGL_INCLUDE_DIR})
    endif()
else()
    add_definitions(-DQMLPLAYER_NO_OPENGL)
endif()

set(qmlplayer_SOURCES main.cpp player.cpp)
qt4_add_resources(qmlplayer_rcc_SOURCES qmlplayer.qrc)

automoc4_add_executable(qmlplayer
    ${qmlplayer_SOURCES}
    ${qmlplayer_rcc_SOURCES}
)
target_link_libraries(qmlplayer
    ${QTGSTREAMER_UI_LIBRARIES}
    ${QT_QTDECLARATIVE_LIBRARY}
    ${qmlplayer_gl_libs}
)

=== examples/recorder/CMakeLists.txt ===
project(qtgst-example-recorder)

if (NOT BUILDING_QTGSTREAMER)
    find_package(QtGStreamer REQUIRED)

    if (${CMAKE_VERSION} VERSION_LESS "2.8.6")
        find_package(Automoc4 REQUIRED)
    else()
        set(CMAKE_AUTOMOC TRUE)

        macro(automoc4_add_executable)
            add_executable(${ARGV})
        endmacro()
    endif()
endif()

include_directories(${QTGSTREAMER_INCLUDES} ${CMAKE_CURRENT_BINARY_DIR})
add_definitions(${QTGSTREAMER_DEFINITIONS})
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${QTGSTREAMER_FLAGS}")

qt4_wrap_ui(recorder_UI_SRCS recorder.ui)
automoc4_add_executable(recorder main.cpp ${recorder_UI_SRCS})
target_link_libraries(recorder ${QTGSTREAMER_LIBRARIES} ${QT_QTGUI_LIBRARY})

=== examples/voip/CMakeLists.txt ===
project(qtgst-example-voip)

if (NOT BUILDING_QTGSTREAMER)
    find_package(QtGStreamer REQUIRED)

    if (${CMAKE_VERSION} VERSION_LESS "2.8.6")
        find_package(Automoc4 REQUIRED)
    else()
        set(CMAKE_AUTOMOC TRUE)

        macro(automoc4_add_executable)
            add_executable(${ARGV})
        endmacro()
    endif()
endif()

include_directories(${QTGSTREAMER_INCLUDES} ${CMAKE_CURRENT_BINARY_DIR})
add_definitions(${QTGSTREAMER_DEFINITIONS})
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${QTGSTREAMER_FLAGS}")

qt4_wrap_ui(voip_UI_SRCS voip.ui)
automoc4_add_executable(voip main.cpp ${voip_UI_SRCS})
target_link_libraries(voip ${QTGSTREAMER_UI_LIBRARIES})

=== src/QGlib/CMakeLists.txt ===
set(QtGLib_SRCS
    quark.cpp
    type.cpp
    paramspec.cpp
    object.cpp
    value.cpp
    signal.cpp
    error.cpp
    connect.cpp
    wrap.cpp
    init.cpp
    ${CMAKE_CURRENT_BINARY_DIR}/gen.cpp
)

set(QtGLib_INSTALLED_HEADERS
    global.h      Global
    init.h        Init
    quark.h       Quark
    type.h        Type
    refpointer.h  RefPointer
    wrap.h
    paramspec.h   ParamSpec
    object.h      Object
    value.h       Value
    signal.h      Signal
    emitimpl.h
    connect.h     Connect
    connectimpl.h
    error.h       Error
)

file(GLOB QtGLib_CODEGEN_HEADERS RELATIVE "${CMAKE_CURRENT_SOURCE_DIR}" "*.h")
list(REMOVE_ITEM QtGLib_CODEGEN_HEADERS "connectimpl.h" "emitimpl.h")

set(QtGLib_CODEGEN_INCLUDES
    -Iglib-object.h
)

# Setup the environment
set(QTGLIB_API_VERSION 2.0)
set(QTGLIB_SOVERSION 0)
include_directories(${CMAKE_CURRENT_BINARY_DIR} ${GOBJECT_INCLUDE_DIR} ${GLIB2_INCLUDE_DIR})

# Add command to generate gen.cpp using codegen
run_codegen("QGlib" "${QtGLib_CODEGEN_INCLUDES}" "${QtGLib_CODEGEN_HEADERS}")

# Build and link QtGLib
automoc4_add_library(QtGLib ${SHARED_OR_STATIC} ${QtGLib_SRCS})
set_target_properties(QtGLib PROPERTIES OUTPUT_NAME QtGLib-${QTGLIB_API_VERSION}
                                          SOVERSION ${QTGLIB_SOVERSION}
                                            VERSION ${QTGSTREAMER_VERSION})
target_link_libraries(QtGLib ${QT_QTCORE_LIBRARY} ${GOBJECT_LIBRARIES})
target_link_libraries(QtGLib LINK_INTERFACE_LIBRARIES ${QT_QTCORE_LIBRARY})

# Install
install(TARGETS QtGLib DESTINATION ${LIB_INSTALL_DIR} EXPORT ${EXPORT_TARGET_SET})
install_headers("QGlib" ${QtGLib_INSTALLED_HEADERS})

=== debian/changelog ===
qt-gstreamer (0.10.2-2ubuntu2) saucy; urgency=low

  * Update symbols

 -- Rohan Garg <rohangarg@kubuntu.org>  Mon, 23 Sep 2013 16:31:31 +0200

qt-gstreamer (0.10.2-2ubuntu1) quantal; urgency=low

  * Merge from Debian unstable, remaining changes:
    - Enable unit tests.
      + Build-depend on gstreamer0.10-plugins-base.

 -- Felix Geyer <debfx@ubuntu.com>  Fri, 15 Jun 2012 15:03:26 +0200

qt-gstreamer (0.10.2-2) unstable; urgency=low

  * Add patch include_path_multiarch.patch to fix the include path
    indicated by QtGStreamerConfig.cmake so that projects using
    cmake + QtGStreamer do not FTBFS (Closes: #676735).

 -- George Kiagiadakis <kiagiadakis.george@gmail.com>  Sun, 10 Jun 2012 14:32:21 +0300

qt-gstreamer (0.10.2-1) unstable; urgency=low

  * New upstream release.
    - Individual glib headers are no longer used (Closes: #665602)
  * Remove all patches: No longer needed, the fixes are upstream.
  * Bump versions of (build-)dependencies:
    - cmake >= 2.8.6
    - gstreamer >= 0.10.33
  * Remove build-deps on automoc, flex and bison.
  * Convert to multiarch.
    - Bump debhelper dependency to version 9.
    - Bump debian/compat to 9.
    - Bump Qt build-dep to version 4.8.1 (needed for QML mutliarch).
    - Add build-dep on dpkg-dev (>= 1.16.1~).
    - Adjust packaging to install libraries and plugins
      to the mutliarch location.
  * Update symbols files.
  * Add a new qtgstreamer-declarative package that contains
    the QtGStreamer QML plugin.
  * Update some package descriptions.
    - Remove articles from the description synopsis to satisfy lintian.
    - Mention the new plugins in qtgstreamer-plugins' package descrption.
  * Update and convert debian/copyright to machine-readable format.
  * Bump standards-version to 3.9.3.
  * Add build dependency on libqt4-opengl-dev for compiling the opengl bits.
  * Set -DUSE_QT_PLUGIN_DIR=OFF in debian/rules to workaround
    a weird issue where QT_IMPORTS_DIR is not found.

 -- George Kiagiadakis <kiagiadakis.george@gmail.com>  Sat, 05 May 2012 13:34:04 +0300

qt-gstreamer (0.10.1-2.1ubuntu1) quantal; urgency=low

  * Merge from Debian unstable, remaining changes:
    - libqtglib-2.0-0.symbols: Add missing symbol.
    - Enable unit tests.
      + Build-depend on gstreamer0.10-plugins-base.
    - Add patch from upstream to fix FTBFS with glib 2.29.
    - Add patch from upstream to fix FTBFS with glib 2.31.
  * Extend boost1.48.patch to make the tests buildable.
  * Bump debhelper compat level to v9 which exports build flags.
  * Update symbols files.

 -- Felix Geyer <debfx@ubuntu.com>  Tue, 01 May 2012 20:19:35 +0200

qt-gstreamer (0.10.1-2.1) unstable; urgency=low

  * Non-Maintainer Upload.
  
  * patches/boost1.48.patch: New.  Work around moc limitation.  Closes:
    #653796.

 -- Steve M. Robbins <smr@debian.org>  Sat, 28 Jan 2012 05:41:39 -0600

=== debian/control ===
Source: qt-gstreamer
Section: libs
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Maintainers of GStreamer packages <pkg-gstreamer-maintainers@lists.alioth.debian.org>
Uploaders: George Kiagiadakis <kiagiadakis.george@gmail.com>
Build-Depends: debhelper (>= 9),
               dpkg-dev (>= 1.16.1~),
               cmake (>= 2.8.6),
               libqt4-dev (>= 4:4.8.1),
               libqt4-opengl-dev (>= 4:4.8.1),
               libboost-dev (>= 1.39),
               libgstreamer0.10-dev (>= 0.10.33),
               libgstreamer-plugins-base0.10-dev (>= 0.10.33),
               gstreamer0.10-plugins-base (>= 0.10.33),
               doxygen,
               graphviz
Standards-Version: 3.9.3
Homepage: http://gstreamer.freedesktop.org

Package: libqtglib-2.0-0
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends},
         libstdc++6 (>= 4.5.0~)
Description: C++ bindings library for GLib and GObject with a Qt-style API
 This package contains the QtGLib library, a library that provides
 C++ bindings for parts of the GLib and GObject APIs with a Qt-syle API.
 The bindings are designed to be easy to use for C++ programmers that are
 used to the Qt API and also provide easier integration with Qt by using
 Qt's data types where applicable.
 .
 This library serves as a base for building the QtGStreamer bindings library.
 .
 This package is part of QtGStreamer.

Package: libqtgstreamer-0.10-0
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: C++ bindings library for GStreamer with a Qt-style API
 This package contains the QtGStreamer library, a library that provides
 C++ bindings for GStreamer with a Qt-style API. The bindings are designed
 to be easy to use for C++ programmers that are used to the Qt API and
 also provide easier integration with Qt by using Qt's data types where
 applicable.

Package: libqtgstreamerui-0.10-0
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends}
Suggests: qtgstreamer-plugins
Description: QtGStreamerUi library
 This package contains the QtGStreamerUi library, a library that provides
 helper classes for integrating GStreamer better in graphical Qt applications.
 .
 This package is part of QtGStreamer.

Package: libqtgstreamerutils-0.10-0
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: QtGStreamerUtils library
 This package contains the QtGStreamerUtils library, a library that provides
 some high level utility classes that can be used with QtGStreamer.
 .
 This package is part of QtGStreamer.

Package: qtgstreamer-plugins
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends}
XB-GStreamer-Version: ${gstreamer:Version}
XB-GStreamer-Elements: ${gstreamer:Elements}
XB-GStreamer-URI-Sources: ${gstreamer:URISources}
XB-GStreamer-URI-Sinks: ${gstreamer:URISinks}
XB-GStreamer-Encoders: ${gstreamer:Encoders}
XB-GStreamer-Decoders: ${gstreamer:Decoders}
Provides: ${gstreamer:Provides}
Description: GStreamer plugins from QtGStreamer
 This package contains GStreamer plugins that are shipped together with
 the QtGStreamer bindings library. These plugins provide GStreamer elements
 that enable better integration of GStreamer in Qt applications.
 .
 Currently, this package contains the qtvideosink, qtglvideosink and
 qwidgetvideosink elements.

Package: qtgstreamer-declarative
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: QML plugins from QtGStreamer
 This package contains QML plugins that are shipped together with the
 QtGStreamer bindings library. These plugins provide QML elements that
 enable better integration of GStreamer in QML-based GUI applications.

Package: libqtgstreamer-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends},
         libqtglib-2.0-0 (= ${binary:Version}),
         libqtgstreamer-0.10-0 (= ${binary:Version}),
         libqtgstreamerui-0.10-0 (= ${binary:Version}),
         libqtgstreamerutils-0.10-0 (= ${binary:Version}),
         libqt4-dev (>= 4:4.8.1),
         libboost-dev (>= 1.39)
Suggests: qtgstreamer-doc
Description: Development headers for QtGStreamer
 QtGStreamer provides C++ bindings for GStreamer with a Qt-style API,
 plus some helper classes for integrating GStreamer better in Qt applications.
 .
 This package provides the necessary development files for building
 C++/Qt applications that use the QtGStreamer library.

Package: qtgstreamer-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Suggests: libqtgstreamer-dev
Description: QtGStreamer API documentation
 QtGStreamer provides C++ bindings for GStreamer with a Qt-style API,
 plus some helper classes for integrating GStreamer better in Qt applications.
 .
 This package contains API documentation for the QtGStreamer library
 in html format, generated from the sources with doxygen.

Package: qtgstreamer-dbg
Section: debug
Priority: extra
Architecture: any
Depends: ${misc:Depends},
         libqtglib-2.0-0 (= ${binary:Version}),
         libqtgstreamer-0.10-0 (= ${binary:Version}),
         libqtgstreamerui-0.10-0 (= ${binary:Version}),
         libqtgstreamerutils-0.10-0 (= ${binary:Version}),
         qtgstreamer-plugins (= ${binary:Version})
Description: Debug symbols for QtGStreamer
 QtGStreamer provides C++ bindings for GStreamer with a Qt-style API,
 plus some helper classes for integrating GStreamer better in Qt applications.
 .
 This package contains the debug symbols for the various binaries shipped
 with QtGStreamer.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk

override_dh_auto_configure:
	dh_auto_configure -- -DQTGSTREAMER_STATIC=OFF \
	                     -DQTGSTREAMER_TESTS=ON \
	                     -DQTGSTREAMER_EXAMPLES=OFF \
	                     -DGST_PACKAGE_NAME="QtGStreamer (Debian)" \
	                     -DGST_PACKAGE_ORIGIN="http://packages.qa.debian.org/qt-gstreamer" \
			     -DLIB_INSTALL_DIR=/usr/lib/$(DEB_HOST_MULTIARCH) \
			     -DUSE_QT_PLUGIN_DIR=OFF

override_dh_auto_build:
	dh_auto_build --parallel -- all doc

override_dh_auto_install:
	dh_auto_install --parallel
	cp -r obj-$(DEB_HOST_GNU_TYPE)/doc debian/tmp/doc

override_dh_gencontrol:
	mkdir -p debian/fake-home
	HOME=debian/fake-home \
	LD_LIBRARY_PATH=debian/qtgstreamer-plugins/usr/lib/$(DEB_HOST_MULTIARCH):$(LD_LIBRARY_PATH) \
	    dh_gstscancodecs
	rm -rf debian/fake-home
	dh_gencontrol

%:
	dh $@ --parallel --dbg-package=qtgstreamer-dbg
